#ifndef OAT_AREA_HPP
#define OAT_AREA_HPP


#include"widget.hpp"


namespace oat{


class
Area: public Widget
{
public:
  using       Callback = void  (*)(Area&  area                     );
  using  MouseCallback = void  (*)(Area&  area, const Mouse&  mouse);

  struct Parameter{
    int  x_base;
    int  y_base;
  };

private:
      Callback      enter_cb=nullptr;
      Callback      leave_cb=nullptr;
      Callback  everytime_cb=nullptr;

      Callback    draw_cb=nullptr;
  MouseCallback  mouse_cb=nullptr;

  Parameter  parameter;

public:
  Area(int  w, int  h);


  void      set_enter_callback(Callback  _cb);
  void      set_leave_callback(Callback  _cb);
  void  set_everytime_callback(Callback  _cb);
  void       set_draw_callback(Callback  _cb);

  void  set_callback(MouseCallback  _cb);

  const Parameter*  operator->() const;

  void  set_base(int  x, int  y);

  void  draw();
  void  process(Mouse&  mouse);

  void  do_on_enter();
  void  do_on_leave();
  void  do_on_everytime();

};




}




#endif




