#include"button_parameter.hpp"
#include<cstdio>




namespace oat{


ButtonParameter::
ButtonParameter()
{
  clear();
}




uint32_t  ButtonParameter::get_count() const{return count;}

bool  ButtonParameter::test_touching()  const{return(flags& touching_flag);}
bool  ButtonParameter::test_touched()   const{return(flags&  touched_flag);}
bool  ButtonParameter::test_untouched() const{return(flags&untouched_flag);}
bool  ButtonParameter::test_pressing()  const{return(flags& pressing_flag);}
bool  ButtonParameter::test_pressed()   const{return(flags&  pressed_flag);}
bool  ButtonParameter::test_unpressed() const{return(flags&unpressed_flag);}


void
ButtonParameter::
clear()
{
  flags = 0;
  count = 0;
}


void
ButtonParameter::
touch()
{
    if(flags&touching_flag)
    {
      flags &= ~touched_flag;
    }

  else
    {
      flags |= touched_flag;
      flags |= touching_flag;
    }
}


void
ButtonParameter::
untouch()
{
    if(flags&touching_flag)
    {
      flags &= ~touching_flag;
      flags &=  ~touched_flag;

      flags |= untouched_flag;
    }

  else
    {
      flags &= ~untouched_flag;
    }
}


void
ButtonParameter::
press()
{
    if(flags&pressing_flag)
    {
      flags &= ~pressed_flag;
    }

  else
    {
      flags |= pressed_flag;
      flags |= pressing_flag;

      flags &= ~unpressed_flag;

      ++count;
    }
}


void
ButtonParameter::
unpress()
{
    if(flags&pressing_flag)
    {
      flags &= ~pressing_flag;
      flags &=  ~pressed_flag;

      flags |= unpressed_flag;
    }

  else
    {
      flags &= ~unpressed_flag;
    }
}


void
ButtonParameter::
print() const
{
  static int  n;

  printf("[button parameter %8d]\n",n++);

    if(test_touched())
    {
      printf("  touched\n");
    }


    if(test_touching())
    {
      printf("  touching\n");
    }


    if(test_untouched())
    {
      printf("  untouched\n");
    }


    if(test_pressed())
    {
      printf("  pressed\n");
    }


    if(test_pressing())
    {
      printf("  pressing\n");
    }


    if(test_unpressed())
    {
      printf("  unpressed\n");
    }
}




}




