#ifndef OAT_BUTTON_PARAMETER_HPP
#define OAT_BUTTON_PARAMETER_HPP


#include<cstdint>


namespace oat{


class
ButtonParameter
{
  enum{
      touched_flag = 0x01,
     touching_flag = 0x02,
    untouched_flag = 0x04,
     pressing_flag = 0x08,
      pressed_flag = 0x10,
    unpressed_flag = 0x20,

  };


  uint32_t  flags;
  uint32_t  count;

public:
  ButtonParameter();


  uint32_t  get_count() const;

  bool  test_touching() const;

  bool    test_touched() const;
  bool  test_untouched() const;

  bool    test_pressing() const;

  bool    test_pressed() const;
  bool  test_unpressed() const;

  void  clear();

  void    touch();
  void  untouch();
  void    press();
  void  unpress();

  void  print() const;

};


}




#endif




