#ifndef OAT_MOUSE_HPP
#define OAT_MOUSE_HPP


#include<cstdint>
#include<SDL.h>
#include"button_parameter.hpp"


namespace oat{


class Widget;


class
Mouse
{
  uint16_t  rel_x;
  uint16_t  rel_y;
  uint16_t  abs_x;
  uint16_t  abs_y;

  int  motion_flag;

public:
  ButtonParameter   left;
  ButtonParameter  right;

  Mouse();

  int  get_rel_x() const;
  int  get_rel_y() const;

  int  get_abs_x() const;
  int  get_abs_y() const;

  bool  test_enter(const Widget&  wid) const;

  void  reset_rel(const Widget&  wid);

  bool  test_motion() const;

  void  button(const SDL_MouseButtonEvent&  evt);
  void  motion(const SDL_MouseMotionEvent&  evt);

  void  clear();

  void  print() const;

};


}




#endif




