#ifndef OAT_SURFACE_HPP
#define OAT_SURFACE_HPP


#include<SDL.h>
#include<cstdint>
#include<string>
#include"util.hpp"


namespace oat{


using Color = uint32_t;


struct
Icon
{
  enum{size=16};

  uint16_t  data[size][size];

};


extern SDL_PixelFormat*  common_format;

extern Color  default_colors[0x8000];


extern const Icon  default_up_icon;
extern const Icon  default_left_icon;
extern const Icon  default_right_icon;
extern const Icon  default_down_icon;

extern const Icon  default_lr_icon;
extern const Icon  default_ud_icon;

extern const Icon  default_double_up_icon;
extern const Icon  default_double_left_icon;
extern const Icon  default_double_right_icon;
extern const Icon  default_double_down_icon;


enum{
  black_color = 0,
  white_color = 0xFFFFFFFF,
};


extern const Color&    red_color;
extern const Color&  green_color;
extern const Color&   blue_color;

extern const Color&             gray_color;
extern const Color&       light_gray_color;
extern const Color&        dark_gray_color;
extern const Color&   deep_dark_gray_color;

const Color&  get_default_color(uint8_t  r, uint8_t  g, uint8_t  b);
const Color&  get_default_color(uint8_t  l                        );

void      get_rgb(uint32_t  v, uint8_t&  r, uint8_t&  g, uint8_t&  b);
uint32_t  map_rgb(             uint8_t   r, uint8_t   g, uint8_t   b);
uint32_t  map_mono(             uint8_t   l                          );

void  reset_font();
void  reset_default_colors();


}




#endif




