#include"tilist.hpp"




Map    map;
RMap  rmap;



namespace{


Widget*
tilemake_widget;


Widget*
mapmake_widget;


Widget*
create_tilemake_widget()
{
  Node*  view = new TableColumn;

  view->insert(painter::widgets.brush_label );
  view->insert(painter::widgets.drawing_area);


  Node*  pal = new TableRow;

  pal->insert(palette8.widgets.area     );
  pal->insert(colorchooser.widgets.node);


  Node*  tools = new TableColumn;

  tools->insert(painter::widgets.radiobox);
  tools->insert(painter::widgets.revolve_widget);
  tools->insert(painter::widgets.reverse_widget);
  tools->insert(painter::widgets.mirror_widget);
  tools->insert(painter::widgets.shift_ud_widget);
  tools->insert(painter::widgets.shift_lr_widget);


  Node*  buttons = new TableColumn;

  buttons->insert(painter::widgets.undo_button);
  buttons->insert(painter::widgets.copy_button);
  buttons->insert(painter::widgets.grid_button);


  Node*  nd = new TableRow;

  nd->insert(view);
  nd->insert(tools);
  nd->insert(buttons);
  nd->insert(pal);

  tilemake_widget = nd;

  return nd;
}


Widget*
create_mapmake_widget()
{
  Node*  nd = new TableRow;

  nd->insert(rmap.widgets.area);
  nd->insert(rmap.widgets.radbox);
  nd->insert(rmap.widgets.chkbox);

  mapmake_widget = nd;

  nd->disable();

  return nd;
}


enum{
  tile_making = 1,
   map_making = 2,
};


void
change(CheckBox&  box, uint32_t  newval, uint32_t  oldval)
{
    switch(newval)
    {
      case(tile_making):
        tilemake_widget->enable();
        mapmake_widget->disable();
        break;
      case(map_making):
        tilemake_widget->disable();
        mapmake_widget->enable();
        break;
    }
}


void
update()
{
   map.widgets.area->request_redraw();
  rmap.widgets.area->request_redraw();
}


}


Widget*
create_united_widget()
{
  Node*  nd = new Node;

  painter::colorchooser.widgets.initialize();
  painter::palette8.widgets.initialize();
  map.widgets.initialize();
  rmap.widgets.initialize();

    rep(i,6)
    {
      int  l = (i? ((i<<5)|0b11111):0);

      palette8.set_color(i,l,l,l);
    }


  painter::reset_whole(Tile::size,Tile::size,8);

  painter::reset_drawing(map.get_tile(0,0));
  painter::push_showing(map.get_tile(0,0));

  painter::set_relative_widgets({map.widgets.area});

  painter::widgets.initialize();


  RadioBox*  radbox = new RadioBox;

  radbox->push(nullptr,u"タイル作成");
  radbox->push(nullptr,u"マップ作成");

  radbox->set_callback(change);


  nd->insert( map.widgets.area          ,  0,  0);
  nd->insert( map.widgets.saving_node   ,340,  0);
  nd->insert(radbox                     ,340,120);
  nd->insert( map.widgets.ud_shift_widget,340,200);
  nd->insert( map.widgets.lr_shift_widget,340,240);
  nd->insert( map.widgets.copy_button,480,200);
  nd->insert( map.widgets.paste_button,480,240);
  nd->insert( map.widgets.tppaste_button,480,280);


  nd->insert(create_tilemake_widget(),0,340);
  nd->insert(create_mapmake_widget() ,0,340);

  return nd;
}


void
update_draw()
{
  painter::widgets.drawing_area->request_redraw();

  map.widgets.area->request_redraw();
  rmap.widgets.area->request_redraw();
}




